/* Main code for Solitaire */

#include <Pilot.h>
#include "callback.h"

#include "solRsc.h"

#define BUFF 80

//#define SOL_DEBUG

/* globals */
char D[55];
int k;

char v(int n)
{
	int v;

	v=D[n]-32;
	return( v>53 ? 53 : v);
}

int e()
{
	int c,i,j,j1,j2;
	char p1[BUFF], p2[BUFF], p3[BUFF];

	//printf("e(): D=%s\n",D);

	/* joker A */
	if (D[53]=='U')
	{
		for(i=52;i>=0;i--)
			D[i+1]=D[i];
		D[0]='U';
	}

	for(i=0;i<54;i++)
		if(D[i]=='U')
		{
			D[i]=D[i+1];
			D[i+1]='U';
			break;
		}

	/* joker B */
	for(j=0;j<2;j++)
	{
		if (D[53]=='V')
		{
			for(i=52;i>=0;i--)
				D[i+1]=D[i];
			D[0]='V';
		}

		for(i=0;i<54;i++)
			if(D[i]=='V')
			{
				D[i]=D[i+1];
				D[i+1]='V';
				break;
			}
	}

	/* triple cut */
	StrCopy(p1,""); StrCopy (p2,""); StrCopy(p3,"");

	//printf("pre D=%s\n",D);

	j1=-1;
	j2=-1;
	for(i=0;i<54;i++)
	{
		if((j1!=-1)&&((D[i]=='U')||(D[i]=='V')))
			j2=i;
		if((j1==-1)&&((D[i]=='U')||(D[i]=='V')))
			j1=i;
	}

	//printf("j1=%d j2=%d\n",j1,j2);

	for(i=0;i<j1;i++)
		p1[i]=D[i];
	p1[j1]='\0';

	for(i=j1;i<=j2;i++)
		p2[i-j1]=D[i];
	p2[j2-j1+1]='\0';

	for(i=j2+1;i<54;i++)
		p3[i-j2-1]=D[i];
	p3[53-j2]='\0';
	

	//printf("p1: %s\np2: %s\np3: %s\n",p1,p2,p3);

	StrCopy(D,"");
	StrCat(D,p3);
	StrCat(D,p2);
	StrCat(D,p1);

	//printf("post D=%s\n",D);

	/* count cut */
	c=v(53);
	for(i=0;i<c;i++)
		p1[i]=D[i];
	for(i=0;i<(53-c);i++)
		D[i]=D[i+c];
	for(i=0;i<c;i++)
		D[53-c+i]=p1[i];

	/* key setup => count cut */
	if(k)
	{
		for(i=0;i<k;i++)
			p1[i]=D[i];
		for(i=0;i<(53-k);i++)
			D[i]=D[i+k];
		for(i=0;i<k;i++)
			D[53-k+i]=p1[i];
		for(i=0;i<BUFF;i++)
		{
			p1[i]='X';
			p2[i]='X';
			p3[i]='X';
		}
		return '\0';
	}

	c=v(v(0));

	for(i=0;i<BUFF;i++)
	{
		p1[i]='X';
		p2[i]='X';
		p3[i]='X';
	}
	if(c>52)
		return(e());
	else
		return(c);
}



/* Get pointer to an object in the current form */
static VoidPtr GetObjectPtr (Word objectID)
{
	FormPtr frm;

        frm = FrmGetActiveForm ();
        return (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, objectID)));
}

/* Get a pointer to the object with focus -- or NULL */
FieldPtr GetFocusObjectPtr(void)
{
	FormPtr frm;
	Int focus;

	frm=FrmGetActiveForm();
	focus=FrmGetFocus(frm);
	if(focus==noFocus)
		return(NULL);
	return(FrmGetObjectPtr(frm,focus));
}

/* show debug box */
void Debug(CharPtr a, CharPtr b, CharPtr c)
{
#ifdef SOL_DEBUG
	FrmCustomAlert(DebugAlert,a,b,c);
#endif
}

/* validate a string to only allow uppercase letters */
void valstr(CharPtr a)
{
	Int i,j;

	for(i=0;i<StrLen(a);i++)
	{
		/* lower -> upper */
		if((*(a+i)>='a')&&(*(a+i)<='z'))
			*(a+i)=*(a+i)-32;
		/* non-letter -> space */
		if((*(a+i)<'A')||(*(a+i)>'z'))
			*(a+i)=' ';
	}

	/* squeeze out spaces */
	for(i=0;i<StrLen(a);i++)
	{
		while(*(a+i)==' ')
			for(j=0;j<StrLen(a+i);j++)
				*(a+i+j)=*(a+i+j+1);
	}
}

void sol(CharPtr iq1, CharPtr q2, CharPtr iqk)
{
	Int f,i,t;
	Char q1[BUFF],qk[BUFF];

	StrCopy(q1,iq1);
	StrCopy(qk,iqk);

	/* validate key and input -- only allow (uppercase) letters */
	valstr(q1);
	valstr(qk);

	/* decrypt (-1) or encrypt (1) */
	if(CtlGetValue(GetObjectPtr(MainEncrypt)))
		f=1;
	else
		f=-1;

	/* set up the deck */
	for(i=0;i<54;i++)
		D[i]=i+33;
	D[54]='\0';

	/* key setup */
        for(i=0;i<StrLen(qk);i++)
        {
                k=*(qk+i)-64;
                t=e();
        }

	Debug("done key setup, D="," ",D);
	k=0;

        /* if encrypting, add 'X' to make length a multiple of 5 */
        if(f==1)
                while(StrLen(q1)%5)
                        StrCat(q1,"X");

        /* do the crypto */
        for(i=0;i<StrLen(q1);i++)
        {
                t=*(q1+i);
                t=t-13;
                t=t+(f*e());
                t=t+26;
                t=t%26;
                t=t+65;
                *(q2+i)=t;
        }
        *(q2+i)='\0';

	/* pretty-print in groups of five letters */
	t=0;
	for(i=0;i<StrLen(q2);i++)
	{
		if((i>0)&&((i%5)==0))
		{
			q1[i+t]=' ';
			t++;
		}
		q1[i+t]=q2[i];
	}
	q1[i+t]='\0';
	StrCopy(q2,q1);

	for(i=0;i<BUFF;i++)
	{
		q1[i]='X';
		qk[i]='X';
	}
}


/* Do the business */
void do_solitaire()
{
	FormPtr frm;
	CharPtr pk,p1,p2;
	VoidHand hk,h1,h2;

	frm=FrmGetActiveForm();

	h1=(VoidHand)FldGetTextHandle(GetObjectPtr(MainF1));
	if(h1==0)
		Debug("h1 is zero!"," "," ");
	h2=(VoidHand)FldGetTextHandle(GetObjectPtr(MainF2));
	if(h2==0)
		Debug("h2 is zero!"," "," ");
	hk=(VoidHand)FldGetTextHandle(GetObjectPtr(MainKey));
	if(hk==0)
		Debug("hk is zero!"," "," ");

	pk=MemHandleLock(hk);
	p1=MemHandleLock(h1);
	p2=MemHandleLock(h2);

	sol(p1,p2,pk);
	
	FldSetText(GetObjectPtr(MainF2),h2,0,MemHandleSize(h2));

	MemHandleUnlock(hk);
	MemHandleUnlock(h1);
	MemHandleUnlock(h2);
	
	FldDrawField(GetObjectPtr(MainF2));
	return;
}


static Boolean MainFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm,aboutFrm;
    VoidHand h;
    CharPtr p;
    FieldPtr fld;
    
    CALLBACK_PROLOGUE

    switch (e->eType) {
    case frmOpenEvent:
	frm = FrmGetActiveForm();
	FrmDrawForm(frm);
    	CtlSetValue(GetObjectPtr(MainEncrypt),1); // start in encrypt mode
	h=MemHandleNew(BUFF*2);
	p=MemHandleLock(h);
	*p='\0';
	MemHandleUnlock(h);
	FldSetText(GetObjectPtr(MainF1),h,0,MemHandleSize(h));
	h=MemHandleNew(BUFF*2);
	p=MemHandleLock(h);
	*p='\0';
	MemHandleUnlock(h);
	FldSetText(GetObjectPtr(MainF2),h,0,MemHandleSize(h));
	h=MemHandleNew(BUFF*2);
	p=MemHandleLock(h);
	*p='\0';
	MemHandleUnlock(h);
	FldSetText(GetObjectPtr(MainKey),h,0,MemHandleSize(h));
	handled = true;
	break;

    case menuEvent:
	MenuEraseStatus(NULL);

	switch(e->data.menu.itemID) {
		case MenuAbout:
			aboutFrm=FrmInitForm(AboutForm);
			FrmDoDialog(aboutFrm);
			FrmDeleteForm(aboutFrm);
			handled=true;
			break;
		case MenuCut:
			fld=GetFocusObjectPtr();
			if(fld)
			{
				FldCut(fld);
				//update form?
			}
			handled=true;
			break;
		case MenuCopy:
			fld=GetFocusObjectPtr();
			if(fld)
			{
				FldCopy(fld);
				//update form?
			}
			handled=true;
			break;
		case MenuPaste:
			fld=GetFocusObjectPtr();
			if(fld)
			{
				FldPaste(fld);
				//update form?
			}
			handled=true;
			break;

	}

    	handled = true;
	break;

    case ctlSelectEvent:
	switch(e->data.ctlSelect.controlID) {
		case MainGo:
			do_solitaire();
			handled=true;
	}
	break;

    default:
        break;
    }

    CALLBACK_EPILOGUE

    return handled;
}

static Boolean ApplicationHandleEvent(EventPtr e)
{
    FormPtr frm;
    Word    formId;
    Boolean handled = false;

    if (e->eType == frmLoadEvent) {
	formId = e->data.frmLoad.formID;
	frm = FrmInitForm(formId);
	FrmSetActiveForm(frm);

	switch(formId) {
	case MainForm:
	    FrmSetEventHandler(frm, MainFormHandleEvent);
	    break;
	}
	handled = true;
    }

    return handled;
}


/* Get preferences, open (or create) app database */
static Word StartApplication(void)
{
    FrmGotoForm(MainForm);
    return 0;
}

/* Save preferences, close forms, close app database */
static void StopApplication(void)
{
	FormPtr frm;
	CharPtr pk,p1,p2;
	VoidHand hk,h1,h2;
	Int i;

	/* clear the deck */
	for(i=0;i<54;i++)
		D[i]='\0';
	D[54]='\0';
	k=0;

	/* clear the fields and buffers */
	frm=FrmGetActiveForm();
	h1=(VoidHand)FldGetTextHandle(GetObjectPtr(MainF1));
	h2=(VoidHand)FldGetTextHandle(GetObjectPtr(MainF2));
	hk=(VoidHand)FldGetTextHandle(GetObjectPtr(MainKey));
	pk=MemHandleLock(hk);
	p1=MemHandleLock(h1);
	p2=MemHandleLock(h2);
	for(i=0;i<(BUFF*2);i++)
	{
		pk[i]='X';
		p1[i]='X';
		p2[i]='X';
	}
	pk[BUFF*2-1]='\0';
	p1[BUFF*2-1]='\0';
	p2[BUFF*2-1]='\0';
	FldSetText(GetObjectPtr(MainKey),hk,0,MemHandleSize(hk));
	FldSetText(GetObjectPtr(MainF1),h1,0,MemHandleSize(h1));
	FldSetText(GetObjectPtr(MainF2),h2,0,MemHandleSize(h2));
	MemHandleUnlock(hk);
	MemHandleUnlock(h1);
	MemHandleUnlock(h2);

	FrmSaveAllForms();
	FrmCloseAllForms();
}

/* The main event loop */
static void EventLoop(void)
{
    Word err;
    EventType e;

    do {
	EvtGetEvent(&e, evtWaitForever);
	if (! SysHandleEvent (&e))
	    if (! MenuHandleEvent (NULL, &e, &err))
		if (! ApplicationHandleEvent (&e))
		    FrmDispatchEvent (&e);
    } while (e.eType != appStopEvent);
}

/* Main entry point; it is unlikely you will need to change this except to
   handle other launch command codes */
DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
    Word err;

    if (cmd == sysAppLaunchCmdNormalLaunch) {

	err = StartApplication();
	if (err) return err;

	EventLoop();
	StopApplication();

    } else {
	return sysErrParamErr;
    }

    return 0;
}
